TITLE Freehafer's Protected Mode Program
;........................................................................
;						; Display Message Macro
;........................................................................
msg	MACRO	msgout			; beginning of macro
	mov AH, 09h				; function 09h
	lea DX, msgout			; DX holds message
	int 21h 				; display string interupt
ENDM						; end of macro
;........................................................................
.MODEL small		      	; directive placing all memory in one segment
.stack 4000
.586
;........................................................................
.data
	Message	DB 10,13,"     This program goes from real to protected mode",10,13,"     to use int 31h to simulate real mode int 21h and,",10,13,"     read the volume label of A using function 7305h.",0Ah,0Dh,"     If you have a floppy in drive A enter 'y' or 'Y'",10,13,"     to proceed.  All other keys exit: ",'$'
	CW		DB 10,13,10,13,"     Freehafer's Mode Program is Terminated!",10,13,"     (c)2002 INNIEA PUBLISHING COMPANY!  R",153,142,"K NOG!",10,13,'$'
	vlmsg		DB 10,13,10,13,"     The volume label of drive A is: ",'$'
	buffy		DB 	512 dup (?)
	dio 		EQU 	THIS BYTE
	diStartSec	DD 0			; sector # to start = 0 for boot
	diSectors	DW 1			; number of sectors to read = 1
	diBuffer	DD DWORD PTR buffy; address of buffer
	County	DW 0
	pme		DD 0			; dos protected mode entry point address
regstruc STRUC
	edi1		DD 0
	esi1		DD 0
	ebp1		DD 0
	res1		DD 0
	ebx1		DD 0
	edx1		DD 0
	ecx1		DD 0
	eax1		DD 0
	flags1	DW 0
	es1		DW 0
	ds1		DW 0
	fs1		DW 0
	gs1		DW 0
	ip1		DW 0
	cs1		DW 0
	sp1		DW 0
	ss1		DW 0
regstruc	ENDS
	reg1		regstruc <>
;........................................................................
;						; Code Segment
;........................................................................
.code
start:     		            	; begin algorithm
;........................................................................
;						; move data segment into DS
;........................................................................
	mov AX, @data	      	; base address
	mov DS, AX		      	; of data segment
;........................................................................
	msg Message				; Display Message With Macro
	mov AH, 1h				; 
	int 21h				; 
	.if(AL != 89 && AL != 121)	; 'y' or 'Y' to proceed
	jmp skippy				; 
	.endif				; 
;........................................................................
;						; allocate memory
;........................................................................
	mov BX, DS			 	; point to start of data segment
						; 	DS = 2572
	mov AX, ES			 	; point to start of PSP set in ES in MASM
						; 	ES = 2546
	sub BX, AX				; # of segments for code & data 
						; 	BX = 2572 - 2546 = 26 *****
	mov AX, SP				; SP is pointing to top of stack area
						; 	AX = 4000 from .stack 
	mov CL, 4				; divide by 16
	shr AX, CL				; 	AX = 250
	add BX, AX				; BX = paragraphs needed 
						; 	BX is 26 + 250 = 276 *****
	mov AH, 4Ah				; modify memory allocation function
	int 21h				; 
;........................................................................
;						; get entry point address and save it
;........................................................................
	mov AX,1687h
	int 2Fh
	mov WORD PTR pme, DI		; ES:DI = segment:offset of procedure
	mov WORD PTR pme + 2, ES	; to call to enter protected mode
;........................................................................
;						; modify above memory allocation
;........................................................................
	mov BX, SI				; paragraphs output from function 1687h
	mov AH, 48h				; modify memory allocation function
	int 21h				; 
;........................................................................
;						; enter protected mode as 16-bit program
;........................................................................
	mov ES, AX				; segment of allocated memory returned
						; from above function
	mov AX, 0				; 0 for 16 bit program
	call pme				; swith to protected mode
	push DS				; save data selector 
	pop GS				; in a safe place
;........................................................................
;						; simulate int 21h
;........................................................................
	mov AX, 300h			; simulate real mode interrupt function
	mov BX, 21h				; interrupt to be simulated
	mov CX, 0				; number of words copied from 
						; protected mode to real mode stack
	push GS				; 
	pop ES				; ES:DI contains structure
	mov DI, offset ES:reg1		; 
	mov WORD PTR reg1.esi1, 0h	; read drive function 
	mov WORD PTR reg1.ecx1, 0FFFFh; -1
	mov WORD PTR reg1.edx1, 1h	; drive A:
	mov WORD PTR reg1.ds1, seg dio 
	mov WORD PTR reg1.ebx1, offset dio
	mov WORD PTR reg1.eax1, 7305h	; read disk function
	int 31h				; 
;........................................................................
;						; Display Volume Label
;........................................................................
	msg vlmsg				; 
	mov County, 43			; 
lloopy:					; 
	mov BX, County			; 
	mov AL, buffy[BX]			; 
	int 29h				; 
	inc County				; 
	.IF(County < 54)			; 
	jmp lloopy				; 
	.ENDIF				; 
skippy:					; 
	msg CW				; display copyright
;........................................................................
;						; End Program
;........................................................................
	mov AX,4C00h			; termination function
	int 21h				; termination interupt
;........................................................................
end  start 			      	; end program
